version 6.0
tempfile entry

use "brazprod\data\life\firms-entry.dta", clear
keep firm first
sort firm
save `entry', replace
use "brazprod\data\life\firms0-all.dta", clear
sort firm
merge firm using `entry'
drop _merge
replace first=first-1900

gen int last=98                            /* Last appearance in sample */
replace last=97 if (ano98==.)
replace last=96 if (ano97==.) & last<98
replace last=95 if (ano96==.) & last<97
replace last=94 if (ano95==.) & last<96
replace last=93 if (ano94==.) & last<95
replace last=92 if (ano93==.) & last<94
replace last=90 if (ano92==.) & last<93
replace last=89 if (ano90==.) & last<92
replace last=88 if (ano89==.) & last<90
replace last=87 if (ano88==.) & last<89
replace last=86 if (ano87==.) & last<88

/* 0: Firm lives continuously during sample period (including late entrants) */
/* Note: Firms that exit or will be acquired are recategorized in analyz-life-emp.do */
/* Note: Firms that enter an installation phase (2) after having had sales are sorted out below */
gen     catlife=0 if first==86 & state86<=2 & state87<=2 & state88<=2 & state89<=2 & state90<=2 & state92<=2 & state93<=2 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal86==1 & indsal87==1 & indsal88==1 & indsal89==1 & indsal90==1 & indsal92==1 & indsal93==1 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==87 & state87<=2 & state88<=2 & state89<=2 & state90<=2 & state92<=2 & state93<=2 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal87==1 & indsal88==1 & indsal89==1 & indsal90==1 & indsal92==1 & indsal93==1 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==88 & state88<=2 & state89<=2 & state90<=2 & state92<=2 & state93<=2 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal88==1 & indsal89==1 & indsal90==1 & indsal92==1 & indsal93==1 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==89 & state89<=2 & state90<=2 & state92<=2 & state93<=2 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal89==1 & indsal90==1 & indsal92==1 & indsal93==1 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==90 & state90<=2 & state92<=2 & state93<=2 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal90==1 & indsal92==1 & indsal93==1 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==92 & state92<=2 & state93<=2 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal92==1 & indsal93==1 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==93 & state93<=2 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal93==1 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==94 & state94<=2 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal94==1 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==95 & state95<=2 & state96<=2 & state97<=2 & state98<=2 & indsal95==1 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==96 & state96<=2 & state97<=2 & state98<=2 & indsal96==1 & indsal97==1 & indsal98==1
replace catlife=0 if first==97 & state97<=2 & state98<=2 & indsal97==1 & indsal98==1
replace catlife=0 if first==98 & state98<=2 & indsal98==1

/* Identify years of missing observations */
/* Note: Missing includes state==8 (with no sales and no change of info) for current purpose */
gen byte miss86=1 if ano86==.
gen byte miss87=1 if ano87==.
gen byte miss88=1 if ano88==.
gen byte miss89=1 if ano89==.
gen byte miss90=1 if ano90==.
gen byte miss92=1 if ano92==.
gen byte miss93=1 if ano93==.
gen byte miss94=1 if ano94==.
gen byte miss95=1 if ano95==.
gen byte miss96=1 if ano96==.
gen byte miss97=1 if ano97==.
gen byte miss98=1 if ano98==.

/* Strange 1: Firm is marked extinct but lives on or reappears */
replace catlife=9.1 if (state86==4 | state86==6 | (state86==8 & (change86==1 | change86==2 | change86==4 | change86==7)) | (state86==8 & change86==. & indcor86==2 & cgcsuc86~=.)) & (indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state87==4 | state87==6 | (state87==8 & (change87==1 | change87==2 | change87==4 | change87==7)) | (state87==8 & change87==. & indcor87==2 & cgcsuc87~=.)) & (indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state88==4 | state88==6 | (state88==8 & (change88==1 | change88==2 | change88==4 | change88==7)) | (state88==8 & change88==. & indcor88==2 & cgcsuc88~=.)) & (indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state89==4 | state89==6 | (state89==8 & (change89==1 | change89==2 | change89==4 | change89==7)) | (state89==8 & change89==. & indcor89==2 & cgcsuc89~=.)) & (indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state90==4 | state90==6 | (state90==8 & (change90==1 | change90==2 | change90==4 | change90==7)) | (state90==8 & change90==. & indcor90==2 & cgcsuc90~=.)) & (indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state92==4 | state92==6 | (state92==8 & (change92==1 | change92==2 | change92==4 | change92==7)) | (state92==8 & change92==. & indcor92==2 & cgcsuc92~=.)) & (indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state93==4 | state93==6 | (state93==8 & (change93==1 | change93==2 | change93==4 | change93==7)) | (state93==8 & change93==. & indcor93==2 & cgcsuc93~=.)) & (indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state94==4 | state94==6 | (state94==8 & (change94==1 | change94==2 | change94==4 | change94==7)) | (state94==8 & change94==. & indcor94==2 & cgcsuc94~=.)) & (indsal95==1 | indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state95==4 | state95==6 | (state95==8 & (change95==1 | change95==2 | change95==4 | change95==7)) | (state95==8 & change95==. & indcor95==2 & cgcsuc95~=.)) & (indsal96==1 | indsal97==1 | indsal98==1)
replace catlife=9.1 if (state96==4 | state96==6 | (state97==8 & (change96==1 | change96==2 | change96==4 | change96==7)) | (state96==8 & change96==. & indcor96==2 & cgcsuc96~=.)) & (indsal97==1 | indsal98==1)
replace catlife=9.1 if (state97==4 | state97==6 | (state98==8 & (change97==1 | change97==2 | change97==4 | change97==7)) | (state97==8 & change97==. & indcor97==2 & cgcsuc97~=.)) & (indsal98==1)
/* Strange 2: Firm is marked as in built-up phase but has been working before */
replace catlife=9.2 if catlife~=float(9.1) & state87==2 & (indsal86==1)
replace catlife=9.2 if catlife~=float(9.1) & state88==2 & (indsal86==1 | indsal87==1)
replace catlife=9.2 if catlife~=float(9.1) & state89==2 & (indsal86==1 | indsal87==1 | indsal88==1)
replace catlife=9.2 if catlife~=float(9.1) & state90==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1)
replace catlife=9.2 if catlife~=float(9.1) & state92==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1)
replace catlife=9.2 if catlife~=float(9.1) & state93==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1)
replace catlife=9.2 if catlife~=float(9.1) & state94==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1)
replace catlife=9.2 if catlife~=float(9.1) & state95==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1)
replace catlife=9.2 if catlife~=float(9.1) & state96==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1)
replace catlife=9.2 if catlife~=float(9.1) & state97==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1)
replace catlife=9.2 if catlife~=float(9.1) & state98==2 & (indsal86==1 | indsal87==1 | indsal88==1 | indsal89==1 | indsal90==1 | indsal92==1 | indsal93==1 | indsal94==1 | indsal95==1 | indsal96==1 | indsal97==1)


label var last "Last Year of Appearance in PIA"
label var catlife "Manual Exit Classification"
label var miss86 "86 missing"
label var miss87 "87 missing"
label var miss88 "88 missing"
label var miss89 "89 missing"
label var miss90 "90 missing"
label var miss92 "92 missing"
label var miss93 "93 missing"
label var miss94 "94 missing"
label var miss95 "95 missing"
label var miss96 "96 missing"
label var miss97 "97 missing"
label var miss98 "98 missing"
format miss86 miss87 miss88 miss89 miss90 miss92 miss93 miss94 miss95 miss96 miss97 miss98 %1.0f
format last %4.0f
format catlife %6.0g

drop first
sort firm
save "brazprod\data\life\firms-exit.dta", replace
