version 6.0
/*----------------------------------*/
/* Careful: Set max size to /k64000 */
/*----------------------------------*/

use "brazprod\data\pia-emp.dta", clear

gen ano=year
gen indsal=1 if sales > 0 & sales~=.
replace indsal=0 if indsal==.
keep firm year ano class state change born indsal cgcsuc cgcemp chmon indcor
drop class
reshape wide ano state change indsal cgcsuc cgcemp chmon indcor, i(firm born) j(year)
capture program drop reform
program define reform
  args yr
  recast byte ano`yr' state`yr' indsal`yr'
  format state`yr' indsal`yr' %1.0f
  format ano`yr' %2.0f
end
reform 86
reform 87
reform 88
reform 89
reform 90
reform 92
reform 93
reform 94
reform 95
reform 96
reform 97
reform 98
gsort +ano86 +ano87 +ano88 +ano89 +ano90 +ano92 +ano93 +ano94 +ano95  +ano96 +ano97 +ano98 -state86 -state87 -state88 -state89 -state90 -state92 -state93 -state94 -state95 -state96 -state97 -state98
order firm ano86 state86 ano87 state87 ano88 state88 ano89 state89 ano90 state90 ano92 state92 ano93 state93 ano94 state94 ano95 state95 ano96 state96 ano97 state97 ano98 state98
/* order firm ano86 ano87 ano88 ano89 ano90 ano92 ano93 ano94 ano95 */
save "brazprod\data\life\firms0-all.dta", replace

/* Continuous presence (possibly exit in 98) */
use "brazprod\data\life\firms0-all.dta", clear
keep if ano86~=. & ano87~=. & ano88~=. & ano89~=. & ano90~=. & ano92~=. & ano93~=. & ano94~=. & ano95~=.  & ano96~=. & ano97~=. & ano98~=.
gsort +ano86 +ano87 +ano88 +ano89 +ano90 +ano92 +ano93 +ano94 +ano95  +ano96 +ano97 +ano98 -state86 -state87 -state88 -state89 -state90 -state92 -state93 -state94 -state95 -state96 -state97 -state98
order firm ano86 state86 ano87 state87 ano88 state88 ano89 state89 ano90 state90 ano92 state92 ano93 state93 ano94 state94 ano95 state95 ano96 state96 ano97 state97 ano98 state98
save "brazprod\data\life\firms1-cont.dta", replace

/* Continuous presence but apparent exit before 98 */
use "brazprod\data\life\firms0-all.dta", clear
drop if ano86~=. & ano87~=. & ano88~=. & ano89~=. & ano90~=. & ano92~=. & ano93~=. & ano94~=. & ano95~=. & ano96~=. & ano97~=. & ano98~=.
/* Drop reappearing firms */
drop if ano98~=. & ano97==. & (ano96~=. | ano95~=. | ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano97~=. & ano96==. & (ano95~=. | ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano96~=. & ano95==. & (ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano95~=. & ano94==. & (ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano94~=. & ano93==. & (ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano93~=. & ano92==. & (ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano92~=. & ano90==. & (ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano90~=. & ano89==. & (ano88~=. | ano87~=. | ano86~=.)
drop if ano89~=. & ano88==. & (ano87~=. | ano86~=.)
drop if ano88~=. & ano87==. & ano86~=.
/* Drop if not included in 86 */
drop if ano86==.
gsort +ano86 +ano87 +ano88 +ano89 +ano90 +ano92 +ano93 +ano94 +ano95 +ano96 +ano97 +ano98 -state86 -state87 -state88 -state89 -state90 -state92 -state93 -state94 -state95 -state96 -state97 -state98
order firm ano86 state86 ano87 state87 ano88 state88 ano89 state89 ano90 state90 ano92 state92 ano93 state93 ano94 state94 ano95 state95 ano96 state96 ano97 state97 ano98 state98
save "brazprod\data\life\firms2-cont-ext.dta", replace

/* Apparently late entry but subsequently continuous presence */
use "brazprod\data\life\firms0-all.dta", clear
drop if ano86~=. & ano87~=. & ano88~=. & ano89~=. & ano90~=. & ano92~=. & ano93~=. & ano94~=. & ano95~=. & ano96~=. & ano97~=. & ano98~=.
/* Drop reappearing firms */
drop if ano98~=. & ano97==. & (ano96~=. | ano95~=. | ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano97~=. & ano96==. & (ano95~=. | ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano96~=. & ano95==. & (ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano95~=. & ano94==. & (ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano94~=. & ano93==. & (ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano93~=. & ano92==. & (ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano92~=. & ano90==. & (ano89~=. | ano88~=. | ano87~=. | ano86~=.)
drop if ano90~=. & ano89==. & (ano88~=. | ano87~=. | ano86~=.)
drop if ano89~=. & ano88==. & (ano87~=. | ano86~=.)
drop if ano88~=. & ano87==. & ano86~=.
/* Keep if not included in 86 */
drop if ano86~=.
gsort +ano86 +ano87 +ano88 +ano89 +ano90 +ano92 +ano93 +ano94 +ano95  +ano96 +ano97 +ano98 -state86 -state87 -state88 -state89 -state90 -state92 -state93 -state94 -state95 -state96 -state97 -state98
order firm ano86 state86 ano87 state87 ano88 state88 ano89 state89 ano90 state90 ano92 state92 ano93 state93 ano94 state94 ano95 state95 ano96 state96 ano97 state97 ano98 state98
save "brazprod\data\life\firms3-cont-late.dta", replace

/* Firm with Apparent Suspension of Production or Apparent Exit but Return */
use "brazprod\data\life\firms0-all.dta", clear
drop if ano86~=. & ano87~=. & ano88~=. & ano89~=. & ano90~=. & ano92~=. & ano93~=. & ano94~=. & ano95~=. & ano96~=. & ano97~=. & ano98~=.
/* Drop reappearing firms */
gen     indic=1 if ano98~=. & ano97==. & (ano96~=. | ano95~=. | ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano97~=. & ano96==. & (ano95~=. | ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano96~=. & ano95==. & (ano94~=. | ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano95~=. & ano94==. & (ano93~=. | ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano94~=. & ano93==. & (ano92~=. | ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano93~=. & ano92==. & (ano90~=. | ano89~=. | ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano92~=. & ano90==. & (ano89~=. | ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano90~=. & ano89==. & (ano88~=. | ano87~=. | ano86~=.)
replace indic=1 if ano89~=. & ano88==. & (ano87~=. | ano86~=.)
replace indic=1 if ano88~=. & ano87==. & ano86~=.
keep if indic==1
drop indic
gsort +ano86 +ano87 +ano88 +ano89 +ano90 +ano92 +ano93 +ano94 +ano95  +ano96 +ano97 +ano98 -state86 -state87 -state88 -state89 -state90 -state92 -state93 -state94 -state95 -state96 -state97 -state98
order firm ano86 state86 ano87 state87 ano88 state88 ano89 state89 ano90 state90 ano92 state92 ano93 state93 ano94 state94 ano95 state95 ano96 state96 ano97 state97 ano98 state98
save "brazprod\data\life\firms4-suspend.dta", replace

/* Mark entries in firms0-all.dta accordingly */
tempfile contgrp
use "brazprod\data\life\firms0-all.dta", clear
preserve
 use "brazprod\data\life\firms1-cont.dta", clear
 keep firm
 sort firm
 save `contgrp', replace
restore
sort firm
merge firm using `contgrp'
gen byte contgrp=1 if _merge==3
drop _merge
preserve
 use "brazprod\data\life\firms2-cont-ext.dta", clear
 keep firm
 sort firm
 save `contgrp', replace
restore
sort firm
merge firm using `contgrp'
replace contgrp=2 if _merge==3
drop _merge
preserve
 use "brazprod\data\life\firms3-cont-late.dta", clear
 keep firm
 sort firm
 save `contgrp', replace
restore
sort firm
merge firm using `contgrp'
replace contgrp=3 if _merge==3
drop _merge
preserve
 use "brazprod\data\life\firms4-suspend.dta", clear
 keep firm
 sort firm
 save `contgrp', replace
restore
sort firm
merge firm using `contgrp'
replace contgrp=4 if _merge==3
drop _merge

label var contgrp "Continuity Indicator"
format contgrp %1.0f
order firm contgrp ano86 state86 ano87 state87 ano88 state88 ano89 state89 ano90 state90 ano92 state92 ano93 state93 ano94 state94 ano95 state95 ano96 state96 ano97 state97 ano98 state98
save "brazprod\data\life\firms0-all.dta", replace
