version 7.0
tempfile temp86 temp87 temp88 temp89 temp90 temp92 temp93 temp94 temp95 temp96 temp97 temp98

capture program drop corrneg
program define corrneg
  args varname
  replace `varname'=. if `varname'<0
end

/* Extract ratios from raw data files */
/*------------------------------------*/

local yr 86
while `yr'<=90 {
disp in yellow "Current Year: 19`yr'"
insheet using "brazprod\pia-e\piae`yr'.csv", clear
keep empresa v0012 v0015 v0017 v0019 v0023 v0103 v0104 v0105 v0109 v0117 v0119 v0124 v0125 v0126 v0127 v0128 v0129 v0130 v0131 v0132 v0133 v0134 v0135 v0138 v0139 v0140
foreach i in "012" "015" "017" "019" "023" "103" "104" "105" "109" "117" "119" "124" "125" "126" "127" "128" "129" "130" "131" "132" "133" "134" "135" "138" "139" "140" {
    quietly replace v0`i'=. if v0`i'==-1
    corrneg v0`i'}
rename empresa firm
gen byte year=`yr'
egen _sum=rsum(v0012 v0017)
gen crrat=_sum/v0023
gen crltrat=v0017/_sum
egen _forsum=rsum(v0015 v0019)
gen crforrat=_forsum/_sum
gen crstfrat=v0015/v0012
gen crltfrat=v0019/v0017
egen _totcost=rsum(v0119 v0132 v0133 v0134 v0135 v0138 v0139 v0140)
gen deprcrat=v0135/_totcost
gen finexrat=v0117/_totcost
egen _totlbco=rsum(v0128 v0129 v0130 v0131)
egen _sal=rsum(v0128 v0129)
gen sallcrat=_sal/_totlbco
gen soclcrat=v0130/_totlbco
gen benlcrat=v0131/_totlbco
gen labtcrat=_totlbco/(_totcost+_totlbco)
gen byte _miss=1 if v0126==. & v0127==.
gen _loss=-v0127
egen _profit=rsum(v0126 _loss v0124 v0125)
replace _profit=. if _miss==1
egen _adjden=rsum(v0103 v0104 v0105)
gen _adjfac=v0109/_adjden
egen _sales=rsum(v0103 v0105)
replace _sales=_adjfac*_sales if _adjfac~=. & _adjfac~=0
gen prfslrat = _profit/_sales
keep  firm year crrat crltrat crforrat crstfrat crltfrat deprcrat finexrat sallcrat soclcrat benlcrat labtcrat prfslrat
order firm year crrat crltrat crforrat crstfrat crltfrat deprcrat finexrat sallcrat soclcrat benlcrat labtcrat prfslrat
sort firm year
save `temp`yr''
local yr=`yr'+1
}

local yr 92
while `yr'<=95 {
disp in yellow "Current Year: 19`yr'"
insheet using "brazprod\pia-e\piae`yr'.csv", clear
keep empresa v0012 v0015 v0017 v0019 v0023 v0056 v0057 v0058 v0062 v0070 v0072 v0077 v0078 v0079 v0080 v0081 v0082 v0083 v0084 v0085 v0086 v0087 v0088 v0089 v0092 v0093 v0094
foreach i in "012" "015" "017" "019" "023" "056" "057" "058" "062" "070" "072" "077" "078" "079" "080" "081" "082" "083" "084" "085" "086" "087" "088" "089" "092" "093" "094" {
    quietly replace v0`i'=. if v0`i'==-1
    corrneg v0`i'}
rename empresa firm
gen byte year=`yr'
egen _sum=rsum(v0012 v0017)
gen crrat=_sum/v0023
gen crltrat=v0017/_sum
egen _forsum=rsum(v0015 v0019)
gen crforrat=_forsum/_sum
gen crstfrat=v0015/v0012
gen crltfrat=v0019/v0017
egen _totcost=rsum(v0072 v0086 v0087 v0088 v0089 v0092 v0093 v0094)
gen deprcrat=v0089/_totcost
gen finexrat=v0070/_totcost
egen _totlbco=rsum(v0082 v0083 v0084 v0085)
egen _sal=rsum(v0082 v0083)
gen sallcrat=_sal/_totlbco
gen soclcrat=v0084/_totlbco
gen benlcrat=v0085/_totlbco
gen labtcrat=_totlbco/(_totcost+_totlbco)
gen byte _miss=1 if v0080==. & v0081==.
gen _loss=-v0081
egen _profit=rsum(v0080 _loss v0077 v0078 v0079)
replace _profit=. if _miss==1
egen _adjden=rsum(v0056 v0057 v0058)
gen _adjfac=v0062/_adjden
egen _sales=rsum(v0056 v0058)
replace _sales=_adjfac*_sales if _adjfac~=. & _adjfac~=0
gen prfslrat = _profit/_sales
keep  firm year crrat crltrat crforrat crstfrat crltfrat deprcrat finexrat sallcrat soclcrat benlcrat labtcrat prfslrat
order firm year crrat crltrat crforrat crstfrat crltfrat deprcrat finexrat sallcrat soclcrat benlcrat labtcrat prfslrat
sort firm year
save `temp`yr''
local yr=`yr'+1
}

local yr 96
while `yr'<=98 {
disp in yellow "Current Year: 19`yr'"
insheet using "brazprod\pia-e\pianova`yr'.csv", clear
* drop if modelo=="S"  /* Drop simplified ("S") questionnaires */
drop firm indsuc indpred
keep empresa x14 x15 x33 x41 x42 x43 x44 x45 x46 x47 x48 v0015 v0016 v0028 v0058 v0061 v0067 v0068 v0074 v0075 percest
rename empresa firm
gen byte year=`yr'
gen _nonop=-x41
egen _totcost=rsum(v0058 x33 _nonop)
gen deprcrat=v0061/_totcost
gen _v0028=-v0028
egen _fexpnd=rsum(v0067 v0068 _v0028)
gen finexrat=_fexpnd/_totcost
rename x42 _totlbco
gen sallcrat=x43/_totlbco
egen _soc=rsum(x44 x45 x46 x47)
gen soclcrat=_soc/_totlbco
gen benlcrat=x48/_totlbco
gen labtcrat=_totlbco/(_totcost+_totlbco)
rename percest intfrrat
gen byte _miss=1 if v0074==. & v0075==.
gen _loss=-v0075
egen _profit=rsum(v0074 _loss)
replace _profit=. if _miss==1
egen _adjden=rsum(x15 v0015 v0016)
gen _adjfac=x14/_adjden
egen _sales=rsum(x15 v0016)
replace _sales=_adjfac*_sales if _adjfac~=. & _adjfac~=0
gen prfslrat = _profit/_sales
keep  firm year deprcrat finexrat sallcrat soclcrat benlcrat labtcrat intfrrat prfslrat
order firm year deprcrat finexrat sallcrat soclcrat benlcrat labtcrat intfrrat prfslrat
sort firm year
by firm year: keep if _n==1
sort firm year
save `temp`yr''
local yr=`yr'+1
}

use `temp86', clear
foreach yr in 87 88 89 90 92 93 94 95 96 97 98 {append using `temp`yr''}
sort firm year
label var firm "Tax Number (CGC)"
label var year "Calendar Year"
label var crrat    "Ratio: Credit in Balance Sum"
label var crltrat  "Ratio: Long-Term Cr./Tot. Credit"
label var crforrat "Ratio: Foreign Cr./Total Credit"
label var crstfrat "Ratio: Foreign Short-Tm./STm Cr."
label var crltfrat "Ratio: Foreign Long-Term/LTm Cr."
label var deprcrat "Ratio: Depreciation/Total Cost"
label var finexrat "Ratio: Financial Exp./Total Cost"
label var sallcrat "Ratio: Salaries/Total Labor Cost"
label var soclcrat "Ratio: Soc.Contrib./Tot.Lab.Cost"
label var benlcrat "Ratio: Benefits/Total Labor Cost"
label var labtcrat "Ratio: Labor Cost/Total Cost"
label var intfrrat "Ratio: Foreign Intm./Tot. Intm."
label var prfslrat "Ratio: Profit (bef. tax)/Sales"

format firm %8.0f
format year %2.0f
format crrat crltrat crforrat crstfrat crltfrat deprcrat finexrat sallcrat soclcrat benlcrat labtcrat intfrrat %9.0g
format finexrat %9.0g
/* 
format crrat crltrat crforrat crstfrat crltfrat deprcrat finexrat sallcrat soclcrat benlcrat labtcrat intfrrat %7.5g
format finexrat %8.3g
*/
replace intfrrat=intfrrat/100

foreach var in "crrat" "crltrat" "crforrat" "crstfrat" "crltfrat" "deprcrat" "sallcrat" "soclcrat" "benlcrat" {corrneg `var'}

compress
save "brazprod\data\pia-ratios", replace 
