* ADDL-SERIES
* (all *.do files  should work with /k32000 memory EXCEPT where noted)

* Order of Commands to Run for PIA at FIRM LEVEL:
* -----------------------------------------------

* [... ADDL-SERIES ...]

* NOTE: Programs in brazcomp/stata/%1prep-secdef/ must be executed first
* do "c:/docume~1/marc/mydocu~1/content/papers/brazcomp/stata/%1prep-secdef/%1OrderOfCommands.do"

cd "c:/data/"
global dp = "c:/data/brazprod/%stata/%2prep-addl-series"
set more off
clear
set mem 80m

* do $dp/prep-deflators.do  
                   /* Prepares output and input deflators for later use */
                   /* Entering data: "brazprod/deflate/mesquita/mesq-deflators.csv"
                                     "brazprod/deflate/pim-deflatores/pim-deflatores.csv"
                                     "brazprod/deflate/fgv/ipa.csv"
                                     "brazprod/deflate/fgv/n100fgv.csv"
                                     "brazprod/deflate/fgv/ipadi.csv"
                                     "brazprod/deflate/fgv/n100ipadi.csv"
                                     "brazprod/deflate/ibge/inpc.csv"
                                     "brazprod/deflate/ibge/otn-ufir.csv"
                                     "brazprod/deflate/us-fedstat/defl-usd-cpia.csv
                                     "brazprod/deflate/us-fedstat/defl-usd-prod.csv"
                                     "brazprod/deflate/us-fedstat/defl-usd-intl.csv"
                                     "brazprod/deflate/niv100-genero-comp.csv"
                                     "brazprod/deflate/genero-fgv-comp.csv"
                                     "brazprod/filters/niv10080.dta" (from prep-filters.do) */
                   /* OUTPUT: "brazprod/deflate/general-defl.dta"
                              "brazprod/deflate/gov-otn-ufir.dta"
                              "brazprod/deflate/comp-defl.dta"
                              "brazprod/deflate/output-defl-`ext'" (where `ext'=mesq,pim,ipa,di)
                              "brazprod/deflate/input-defl-`ext'" (where `ext'=mesq,pim,ipa,di) */


* do $dp/prep-intl-series.do 
                    /* Creates real exchange rate, penetration, and tariff time series */
                    /* Entering data: "brazprod/addl/mesq-penet.csv"" (originally "Mesq Moreira Serie.xls")
                                      "brazprod/addl/ramos-penet-imp.csv"" (originally "Ramos&Zonenschain_BrazilTradePerformance.pdf" and "TD MX.doc" which in turn were transformed to "Olinto Ramos Penetracao.xls")
                                      "brazprod/addl/ramos-penet-exp.csv"" (originally "Ramos&Zonenschain_BrazilTradePerformance.pdf" and "TD MX.doc" which in turn were transformed to "Olinto Ramos Penetracao.xls")
                                      "brazprod/addl/kume-nominal.csv"" (originally "Kume Tarifa nominal 2.xls")
                                      "brazprod/deflate/contas-nacionais/in-out-`yr'.csv (originals Tabela02-`yr'.xls, where `yr' 85, 90, 91, ..., 98; goto sheet "CI Atividades (Volume)", delete rows 1 and 2, copy Nivel80 from A3 to A1, delete rows 2 and 3, delete column B, save as *.csv; -85-orig is original while -85-transpo is produced file for use)
                                      "brazprod/deflate/contas-nacionais/cap-form-`yr'.csv (originals Tabela01-85.xls and Tabela02-`yr'.xls, where `yr' 86, 90, 91, ..., 98; goto sheet "Demanda Final (Volume)", delete rows 1 and 2, copy Nivel80 from A3 to A1, delete rows 2 and 3, delete column B, save as *.csv)
                                      "brazprod/filters/niv10080.dta" (from prep-filters.do)
                                      "brazprod/deflate/comp-defl.dta" (from prep-deflators.do)
                                      "brazprod/deflate/general-defl.dta" (from prep-deflators.do)
                                      "brazprod/deflate/fgv/dollar.csv" */                    
                    /* Output: "brazprod/addl/imp-penetrat.dta",
                               "brazprod/addl/tariffs.dta",
                               "brazprod/addl/tariffs-outp.dta",
                               "brazprod/addl/tariffs-intm.dta",
                               "brazprod/addl/tariffs-cap.dta",
                               "brazprod/addl/tariffs-intm-monthly.dta",
                               "brazprod/addl/tariffs-cap-monthly.dta",
                               "brazprod/deflate/realexch.dta",
                               "brazprod/filters/sectors.dta" */


* do $dp/ppi-oecd.do  /* Creates Niv100 PPI series 1986-1998 from OECD data */
                    /* Entering data: "brazprod/filters/oecd-ppi.csv"
                                      "brazprod/filters/niv100.csv" 
                                      "brazprod/filters/niv100-oecd-ppi.csv"
                                      "brazprod/addl/ivs/ppi-oecd/oecd-use.csv" */
                    /* Output: "brazprod/filters/nivdef.dta"
                               "brazprod/filters/niv100-oecd-conc.dta"
                               "brazprod/addl/ivs/ppi-oecd/oecd-ppi.dta" 
                        LaTeX: "c:/texdocs/brazcomp/brsecdef/stata-origs/niv100-oecd-conc.tex" */

* do $dp/ppi-us.do    /* Creates Niv100 PPI series 1986-1998 from US BLS data */
                    /* Entering data: "brazcomp/filters/sic2niv-loose.dta" (from /brazcomp)
                                      "brazprod/addl/ivs/ppi-us/pc.series"
                                      "brazprod/addl/ivs/ppi-us/pc.industry"
                                      "brazprod/addl/ivs/ppi-us/pc.data.`ser'" (where `ser' in 1.MetalMining 10.Lumber 11.Furniture 12.Paper 13.Printing 14.Chemicals 15.Petroleum 16.Rubber 17.Leather 18.Stone 19.PrimaryMetal 20.FabricatedMetal 21.Machinery 22.ElectricalMachinery 23.TransportationEquipment 24.MeasuringInstruments 25.Miscellaneous 3.BituminousAndLignite 4.OilAndGas 5.NonMetallicMining 6.Food 7.Tobacco 8.Textile 9.Apparel) */
                    /* Output: "brazprod/filters/us-sectors.dta"
                               "brazprod/addl/ivs/ppi-us/us-ppi.dta" */

* do $dp/wpi-world.do /* Creates annual WPI, CPI, and PPI series from globalfindata */
                    /* Entering data: "brazprod/addl/ivs/findata/PPI/`country'.csv", where `country' stands for "belgium" "canada" "france" "germany" "korea" "netherlands" "spain" "sweden" "switzerland" "uk" "usa",
                                      "brazprod/addl/ivs/findata/WPI/`country'.csv", where `country' stands for "argentina" "chile" "italy" "japan" "mexico" "singapur" "taiwan" "uruguay" "venezuela",
                                      "brazprod/addl/ivs/findata/CPI/`country'.csv", where `country' stands for "china" "hongkong" "panama" "paraguay" "saudiarabia" */
                    /* Output: "brazprod/addl/ivs/findata/world-wpi-cpi-ppi.dta" */


* do $dp/prep-foreign-prices.do
                    /* Creates sector-specific foreign price series for use with deflation */
                    /* Entering data: "brazprod/filters/niv100-oecd-conc.dta" (from ppi-oecd.do)
                                      "brazprod/addl/ivs/ppi-oecd/oecd-ppi.dta" (from ppi-oecd.do)
                                      "brazprod/deflate/realexch.dta" (from prep-intl-series.do)
                                      "brazprod/addl/ivs/ppi-us/us-ppi.dta" (from ppi-us.do)
                                      "brazprod/addl/ivs/brazil-trade/aladi-origins.csv" */
                    /* Output: "brazprod/deflate/foreign-ppi.dta"
                               "brazprod/addl/ivs/world-wpi-cpi-ppi-sectoral.dta"
                               "brazprod/deflate/foreign-mix.dta" */

* do $dp/prep-deflators-input.do
                   /* Prepares input deflators on the basis of tariffs and foreign prices */
                   /* Entering data: "brazprod/deflate/contas-nacionais/in-out-`yr'.csv" (`yr'=85,90,92,...,98)
                                     "brazprod/deflate/contas-nacionais/in-out-85-orig.csv"
                                     "brazprod/deflate/comp-defl.dta" (from prep-deflators.do)
                                     "brazprod/deflate/output-defl-`ext'.dta" (where `ext'=mesq,pim,ipa,di; from prep-deflators.do)
                                     "brazprod/deflate/foreign-ppi.dta" (from prep-foreign-prices.do) 
                                     "brazprod/addl/tariffs-intm-monthly.dta" (from prep-intl-series.do)
                                     "brazprod/filters/niv10080.dta" (from prep-filters.do) */
                   /* OUTPUT: "brazprod/deflate/contas-nacionais/in-out-85-transpo.csv"
                              "brazprod/deflate/input-defl-`ext'.dta" (where `ext'=mesq,pim,ipa,di,forppi`fdfl') */

* do $dp/prep-deflators-capital.do
                   /* Prepares capital and investment deflators on the basis of tariffs and foreign prices */
                   /* Entering data: "brazprod/deflate/contas-nacionais/cap-form-`yr'.csv" (`yr'=85,90,92,...,98)
                                     "brazprod/deflate/comp-defl.dta" (from prep-deflators.do)
                                     "brazprod/deflate/output-defl-`ext'.dta" (where `ext'=mesq,pim,ipa,di; from prep-deflators.do)
                                     "brazprod/deflate/foreign-ppi.dta" (from prep-foreign-prices.do) 
                                     "brazprod/addl/tariffs-cap-monthly.dta" (from prep-intl-series.do)
                                     "brazprod/filters/niv10080.dta" (from prep-filters.do) */
                   /* OUTPUT: "brazprod/deflate/capform-defl-`ext'.dta" (where `ext'=mesq,pim,ipa,di,forppi`fdfl') */


* do $dp/prep-interest-rate-series.do 
                    /* Creates interest rate time series */
                    /* Entering data: "brazprod/addl/interest/andima/poupanca-use.csv" (original: poupanca-orig.csv)
                                      "brazprod/deflate/ibge/inpc-79-mtb-64.csv"
                                      "brazprod/deflate/fgv/igpdi-44.csv"
                                      "brazprod/deflate/fgv/ipadi-69.csv" */
                    /* Output: "brazprod/addl/interest.dta" */


* do $dp/exp-imp-89-98.do
                    /* Creates imports-exports files */
                    /* Entering data: "brazprod/exp-imp/exp`yr'.csv" (originals: Bxp80`yr.dbf from FUNCEX)
                                      "brazprod/exp-imp/imp`yr'.csv" (originals: Bmp80`yr.dbf from FUNCEX)
                                      "brazprod/deflate/comp-defl.dta" (from prep-deflators.do)
                                      "brazprod/filters/niv10080.dta" (from prep-filters.do)
                                      "brazprod/deflate/realexch.dta" (from prep-intl-series.do)
                                      "brazprod/pia-e/pianova`yr'.csv" (where `yr' is 96, 97, 98) */
                    /* OUTPUT: "brazprod/exp-imp/exp-imp.dta" */


* do $dp/prep-fdi.do  /* Creates FDI series 1980-2000 */
                    /* Entering data: "brazprod/addl/fdi/fdi80-95.csv",
                                      "brazprod/addl/fdi/fdi95-00.csv" */
                    /* Output: "brazprod/addl/fdi.dta",
                               "brazprod/addl/fdi.csv",
                               "brazprod/addl/fdi-use.dta" */


* do $dp/prep-ivs-annual.do  
                    /* Creates annual foreign inflation series for use as instrumental variables */
                    /* Entering data: "brazprod/addl/ivs/findata/world-wpi-cpi-ppi.dta" (from wpi-world.do)
                                      "brazprod/addl/ivs/brazil-trade/aladi-origins.csv"
                                      "brazprod/deflate/realexch.dta" (from prep-intl-series.do)
                                      "brazprod/deflate/ibge/inpc-79-mtb-64.csv" */
                    /* Output: "brazprod/addl/ivs-annual.dta" */

* do $dp/prep-ivs-sectoral.do  
                    /* Creates sector-specific inflation series for use as instrumental variables */
                    /* Entering data: "brazprod/filters/niv100-oecd-conc.dta" (from ppi-oecd.do)
                                      "brazprod/addl/ivs/ppi-oecd/oecd-ppi.dta" (from ppi-oecd.do)
                                      "brazprod/addl/ivs/ppi-us/us-ppi.dta" (from ppi-us.do)
                                      "brazprod/deflate/output-defl-di.dta" (from prep-deflators.do)
                                      "brazprod/addl/ivs-annual.dta" (from prep-ivs-annual.do)
                                      "brazprod/addl/ivs/world-wpi-cpi-ppi-sectoral.dta" (from prep-foreign-prices.do)
                                      "brazprod/addl/ivs/brazil-trade/aladi-origins.csv" */
                    /* Output: "brazprod/addl/ivs-sectoral.dta"
                               "brazprod/filters/oecdctry.do" (label oecdctry) */
