version 7.0
tempfile otn
tempfile n100fgv master tmp0 tmp1 tmp2
tempfile capf85 capf86 capf87 capf88 capf89 capf90 capf91 capf92 capf93 capf94 capf95 capf96 capf97 capf98
tempfile c62 c63 c64 c65 c66 c67 c68 c69 c70 c71 c72 c73 c74 c75 c76 c77 c78 c79 c80 c81 c82 c83 c84 c85 c86 c87 c88 c89 c90 c91 c92 c93 c94 c95 c96 c97 c98
tempfile cap1 cap2 cap3 cap4 cap5
local lstyr 98

local totyr  14
local bldgyr 25
local machyr 10
local veicyr  5
local compyr  4
local othryr  6

/* Produced Deflators  1: INPC    64-98 */
/*                     2: OTN+    64-98 */
/*                     3: IPA-DI  44-69 */
/*                     4: FGV-IPA 69-98 */
/*                     5: FGV-DI  69-98 */
/* All deflator types will be created in loops */

/* OTN */
/*------*/
insheet using "brazprod\deflate\ibge\otn-ufir-64.csv", clear
drop if substr(data,5,2)=="99" | data==""
local otnfact=otnfinal[302]   /* February 1989 */
gen govativo=otn
gen govbaixa=otnbaixa
replace govativo=otnvelho if govativo==.
replace govbaixa=otnvelho if govbaixa==.
replace govativo=`otnfact'*btn if govativo==.
replace govbaixa=`otnfact'*btn if govbaixa==.
replace govativo=`otnfact'*fap if govativo==.
replace govbaixa=`otnfact'*fap if govbaixa==.
replace govativo=`otnfact'*ufir if govativo==.
replace govbaixa=`otnfact'*ufir if govbaixa==.
gen int year=real(substr(data,5,2))+1900
egen byte month=fill(1(1)12 1(1)12)
gen date=ym(year,month)
format date %tm
drop month year
order data date
/* Transform deflators to base "Real" 1995 */
capture program drop nominal
program define nominal
  args varname
  replace `varname'=`varname'/(2.75*1000000000) if date<=ym(1986,2)
  replace `varname'=`varname'/(2.75*1000000) if date>ym(1986,2) & date<=ym(1993,7)
  replace `varname'=`varname'/(2.75*1000) if date>ym(1993,7) & date<=ym(1994,6)
end
nominal otn
nominal otnbaixa
nominal otnfinal
nominal fap
nominal ufir
nominal govativo
nominal govbaixa
keep date gov*
replace govativo=govativo[10]  if date<=ym(1964,9)   /* Oct-1964==10 is first observation */
replace govbaixa=govbaixa[10]  if date<=ym(1964,9)
expand 25 if _n==1  /* Add 1962 */
sort date
replace date=23+_n if _n<25
/* Calculate denominator for each year and capital type */
gen sigmam=.
local yr=86
while `yr'<=91 {
local currmo=((19`yr'-1961)*12)     /* This series starts in Jan-1962 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1bld`yr'=sum(_dum1)
egen ot2bld`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1tot`yr'=sum(_dum1)
egen ot2tot`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1mac`yr'=sum(_dum1)
egen ot2mac`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`othryr'    /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1oth`yr'=sum(_dum1)
egen ot2oth`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1veh`yr'=sum(_dum1)
egen ot2veh`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1com`yr'=sum(_dum1)
egen ot2com`yr'=sum(_dum2)
drop _dum1 _dum2
local yr=`yr'+1
}
drop if date<=ym(1991,11)
expand 300 if date==ym(1991,12)
sort date
replace date=_n+83 if _n<=299
local yr 92
while `yr'<=98 {
local currmo=((19`yr'-1966)*12)     /* This series starts in Jan-1967 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1bld`yr'=sum(_dum1)
egen ot2bld`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1tot`yr'=sum(_dum1)
egen ot2tot`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1mac`yr'=sum(_dum1)
egen ot2mac`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`othryr'    /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1oth`yr'=sum(_dum1)
egen ot2oth`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1veh`yr'=sum(_dum1)
egen ot2veh`yr'=sum(_dum2)
drop _dum1 _dum2
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dum1=(govativo[`currmo']/govativo)*sigmam
gen _dum2=(govbaixa[`currmo']/govbaixa)*sigmam
egen ot1com`yr'=sum(_dum1)
egen ot2com`yr'=sum(_dum2)
drop _dum1 _dum2
local yr=`yr'+1
}
drop date gov* sigmam
keep in 1
gen id=1
reshape long ot1bld ot2bld ot1tot ot2tot ot1mac ot2mac ot1oth ot2oth ot1veh ot2veh ot1com ot2com, i(id) j(year)
drop id
sort year
save `otn'

/* INPC */
/*------*/
insheet using "brazprod\deflate\ibge\inpc-79-mtb-64.csv", clear
local factor=igpmtb[183]/inpc[183]
replace inpc=`factor'*inpc
replace inpc=igpmtb if inpc==.
drop igpmtb
rename inpc inpcigpc
gen int year=real(substr(data,5,2))+1900
replace year=year+100 if year<1950
egen byte month=fill(1(1)12 1(1)12)
gen date=ym(year,month)
drop month year data
rename date month
format month %tm
drop if month>ym(1998,12)
order month inpcigpc
expand 25 if _n==1
sort month
replace month=23+_n if _n<25
/* Calculate numerator for each year and capital type */
gen sigmam=.
local yr=86
while `yr'<=91 {
local currmo=((19`yr'-1961)*12)     /* This series starts in Jan-1962 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen buildg`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'     /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'     /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'     /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop if month<=ym(1991,11)
expand 300 if month==ym(1991,12)
sort month
replace month=_n+83 if _n<=299
local yr 92
while `yr'<=98 {
local currmo=((19`yr'-1966)*12)     /* This series starts in Jan-1967 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen buildg`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'     /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'     /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'     /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(inpcigpc[`currmo']/inpcigpc)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop month inpcigpc sigmam
keep in 1
gen id=1
reshape long buildg total machin othr vehicl comput, i(id) j(year)
drop id
sort year
merge year using `otn'
drop _merge
gen buildgas=buildg/ot1bld
gen buildgsl=buildg/ot2bld
gen totalas=total/ot1tot
gen totalsl=total/ot2tot
gen machinas=machin/ot1mac
gen machinsl=machin/ot2mac
gen otheras=othr/ot1oth
gen othersl=othr/ot2oth
gen vehiclas=vehicl/ot1veh
gen vehiclsl=vehicl/ot2veh
gen computas=comput/ot1com
gen computsl=comput/ot2com
drop buildg machin vehicl total othr comput ot1* ot2*
label var year "Calendar Year"
label var buildgas "Corr. Factor Buildings (Stock)"
label var buildgsl "Corr. Factor Buildings (Sales)"
label var totalas "Corr. Factor Total (Stock)"
label var totalsl "Corr. Factor Total (Sales)"
label var machinas "Corr. Factor Machinery (Stock)"
label var machinsl "Corr. Factor Machinery (Sales)"
label var otheras "Corr. Factor Other (Stock)"
label var othersl "Corr. Factor Other (Sales)"
label var vehiclas "Corr. Factor Vehicles (Stock)"
label var vehiclsl "Corr. Factor Vehicles (Sales)"
label var computas "Corr. Factor Computers (Stock)"
label var computsl "Corr. Factor Computers (Sales)"
order year buildgas buildgsl machinas machinsl vehiclas vehiclsl computas computsl otheras othersl totalas totalsl
sort year
save "brazprod\deflate\capcorr-inpc.dta", replace

/* IGP-DI */
/*--------*/
insheet using "brazprod\deflate\fgv\igpdi-44.csv", clear
drop v3
rename v1 data
drop if real(substr(data,5,2))>=99 | real(substr(data,5,2))<=61 | data==""
gen int year=real(substr(data,5,2))+1900
egen byte month=fill(1(1)12 1(1)12)
gen date=ym(year,month)
format date %tm
drop month year data
rename date month
order month
/* Calculate numerator for each year and capital type */
gen sigmam=.
local yr=86
while `yr'<=91 {
local currmo=((19`yr'-1961)*12)     /* This series starts in Jan-1962 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen buildg`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'    /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop if month<=ym(1991,11)
expand 300 if month==ym(1991,12)
sort month
replace month=_n+83 if _n<=299
local yr 92
while `yr'<=98 {
local currmo=((19`yr'-1966)*12)     /* This series starts in Jan-1967 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen buildg`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'    /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(igpdi[`currmo']/igpdi)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop month igpdi sigmam
keep in 1
gen id=1
reshape long buildg total machin othr vehicl comput, i(id) j(year)
drop id
sort year
merge year using `otn'
drop _merge
gen buildgas=buildg/ot1bld
gen buildgsl=buildg/ot2bld
gen totalas=total/ot1tot
gen totalsl=total/ot2tot
gen machinas=machin/ot1mac
gen machinsl=machin/ot2mac
gen otheras=othr/ot1oth
gen othersl=othr/ot2oth
gen vehiclas=vehicl/ot1veh
gen vehiclsl=vehicl/ot2veh
gen computas=comput/ot1com
gen computsl=comput/ot2com
drop buildg total machin othr vehicl comput ot1* ot2*
label var year "Calendar Year"
label var buildgas "Corr. Factor Buildings (Stock)"
label var buildgsl "Corr. Factor Buildings (Sales)"
label var totalas "Corr. Factor Total (Stock)"
label var totalsl "Corr. Factor Total (Sales)"
label var machinas "Corr. Factor Machinery (Stock)"
label var machinsl "Corr. Factor Machinery (Sales)"
label var otheras "Corr. Factor Other (Stock)"
label var othersl "Corr. Factor Other (Sales)"
label var vehiclas "Corr. Factor Vehicles (Stock)"
label var vehiclsl "Corr. Factor Vehicles (Sales)"
label var computas "Corr. Factor Computers (Stock)"
label var computsl "Corr. Factor Computers (Sales)"
order year buildgas buildgsl machinas machinsl vehiclas vehiclsl computas computsl otheras othersl totalas totalsl
sort year
save "brazprod\deflate\capcorr-igp-di.dta", replace

/* IPA-DI */
/*--------*/
insheet using "brazprod\deflate\fgv\ipadi-69.csv", clear
rename v1 data
drop if real(substr(data,5,2))>=99 | real(substr(data,5,2))<=61 | data==""
gen int year=real(substr(data,5,2))+1900
egen byte month=fill(1(1)12 1(1)12)
gen date=ym(year,month)
format date %tm
drop month year data
rename date month
order month
replace bcd=bcd[7] if month<=ym(1969,6)       /* Jul-1969 is first observation */
replace bcdud=bcdud[7] if month<=ym(1969,6)
replace bcnd=bcnd[7] if month<=ym(1969,6)
replace maq=maq[7] if month<=ym(1969,6)
replace veiculos=veiculos[7] if month<=ym(1969,6)
drop compveic trans
expand 85 if _n==1  /* Add 1962 */
sort month
replace month=23+_n if _n<85
keep month ipadi maq veiculos bcdud
/* Error Correction */
capture program drop errdi
program define errdi
   args varname
   replace `varname'=`varname'/1000000000000000000 if `varname'>100000000000000000
end
errdi ipadi
errdi bcdud
errdi maq
errdi veiculos
/* Calculate numerator for each year and capital type */
gen sigmam=.
local yr=86
while `yr'<=91 {
local currmo=((19`yr'-1961)*12)     /* This series starts in Jan-1962 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dummy=(ipadi[`currmo']/ipadi)*sigmam
egen buildg`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(ipadi[`currmo']/ipadi)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(maq[`currmo']/maq)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'    /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(ipadi[`currmo']/ipadi)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(veiculos[`currmo']/veiculos)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(bcdud[`currmo']/bcdud)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop if month<=ym(1991,11)
expand 300 if month==ym(1991,12)
sort month
replace month=_n+83 if _n<=299
local yr 92
while `yr'<=98 {
local currmo=((19`yr'-1966)*12)     /* This series starts in Jan-1967 */
replace sigmam=_n-`currmo'+12*`bldgyr'    /* `bldgyr' years for buildings */
replace sigma=. if sigmam<1 | sigmam>(12*`bldgyr')
gen _dummy=(ipadi[`currmo']/ipadi)*sigmam
egen buildg`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(ipadi[`currmo']/ipadi)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(maq[`currmo']/maq)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'     /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(ipadi[`currmo']/ipadi)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(veiculos[`currmo']/veiculos)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(bcdud[`currmo']/bcdud)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop month ipadi bcdud maq veiculos sigmam
keep in 1
gen id=1
reshape long buildg total machin othr vehicl comput, i(id) j(year)
drop id
sort year
merge year using `otn'
drop _merge
gen buildgas=buildg/ot1bld
gen buildgsl=buildg/ot2bld
gen totalas=total/ot1tot
gen totalsl=total/ot2tot
gen machinas=machin/ot1mac
gen machinsl=machin/ot2mac
gen otheras=othr/ot1oth
gen othersl=othr/ot2oth
gen vehiclas=vehicl/ot1veh
gen vehiclsl=vehicl/ot2veh
gen computas=comput/ot1com
gen computsl=comput/ot2com
drop buildg total machin othr vehicl comput ot1* ot2*
label var year "Calendar Year"
label var buildgas "Corr. Factor Buildings (Stock)"
label var buildgsl "Corr. Factor Buildings (Sales)"
label var totalas "Corr. Factor Total (Stock)"
label var totalsl "Corr. Factor Total (Sales)"
label var machinas "Corr. Factor Machinery (Stock)"
label var machinsl "Corr. Factor Machinery (Sales)"
label var otheras "Corr. Factor Other (Stock)"
label var othersl "Corr. Factor Other (Sales)"
label var vehiclas "Corr. Factor Vehicles (Stock)"
label var vehiclsl "Corr. Factor Vehicles (Sales)"
label var computas "Corr. Factor Computers (Stock)"
label var computsl "Corr. Factor Computers (Sales)"
order year buildgas buildgsl machinas machinsl vehiclas vehiclsl computas computsl otheras othersl totalas totalsl
sort year
save "brazprod\deflate\capcorr-di.dta", replace


/* IPA-OG */
/*========*/

/* Create Temp. Capital Formation Vectors */
/*----------------------------------------*/
/* Niv80 x Capital Formation Vector (for all industries), 90-98 */
local yr 90
while `yr'<=98 {
insheet using "brazprod\deflate\contas-nacionais\cap-form-`yr'.csv", clear
drop if nivel80==.
rename nivel80 niv80
rename capitalf capform
label var capform "Capital Formation"
sort niv80
drop if niv80==9999
save `capf`yr'', replace
local yr=`yr'+1
}
/* Make vectors 1986-1989 from 1985 and 1990 */
/* Method: W85 + (DIFF/5)*Step = W90 */
insheet using "brazprod\deflate\contas-nacionais\cap-form-85.csv", clear
drop if nivel80==9999
drop if nivel80==.
rename nivel80 niv80
rename capital capform
label var capform "Capital Formation"
sort niv80
drop if niv80==9999
save `capf85', replace
rename capform start
sort niv80
merge niv80 using `capf90'
drop _merge
    quietly egen tot=sum(capform)
    replace capform=capform/tot
    drop tot
    quietly egen tot=sum(start)
    replace start=start/tot
    drop tot
local step 1
while `step'<=4 { 
gen new=start+`step'*((capform-start)/5)
preserve
    local yr=`step'+85
    keep niv80 new
    rename new capform
    label var capform "Share in Capital Formation"
    sort niv80
    save `capf`yr'', replace
restore
drop new
local step=`step'+1
}

/* Read-in raw price indices */
/*---------------------------*/
    insheet using "brazprod\deflate\fgv\n100fgv.csv", clear
    keep nivel100 coluna
    rename colunaco coluna
    rename nivel100 niv100
    label var niv100 "Sector of Industry (NIV100)"
    sort niv100
    merge niv100 using "brazprod\filters\niv10080", nokeep
    drop _merge
    label var niv80 "Sector of Industry (NIV80)"
    sort coluna
    save `n100fgv', replace
set matsize 445
insheet using "brazprod\deflate\fgv\ipaog-69.csv", clear
/* Error Correction */
capture program drop errog
program define errog
   args varname
   quietly replace `varname'=`varname'/100000000000000000 if `varname'>=100000000000000000
end
local i 2
while `i'<=68 {
    errog v`i'
    local i=`i'+1
    }
local round 1
while `round'<=2 {
 local i 2
 while `i'<=68 {
    local n 1
    while `n'<=385 {
     if v`i'[`n']>=10*v`i'[`n'-1] & v`i'[`n']~=. {disp "v`i': `n'"
                                    replace v`i'=v`i'/10 if _n>=`n' 
                                    }
         local n=`n'+1
     }
    local i=`i'+1
    }
local round=`round'+1
}
rename v1 data
drop if (substr(data,5,2))=="99" | (substr(data,5,2))=="00"
gen int year=real(substr(data,5,2))+1900 if _n>=2
egen byte month=fill(1(1)12 1(1)12)
replace month=month-1
replace month=12 if month==0
gen date=ym(year,month)
format date %tm
drop month year
order data date
rename date month
drop if month<ym(1969,7)
sort month
expand 91 if _n==1  /* Add 1962 */
sort month
replace month=23+_n if month<=ym(1969,7)
drop data
/* Insert code for missing series here */
capture program drop subst
program define subst
    args var subst fstobs
    replace `var'=`subst'/`subst'[`fstobs']*`var'[`fstobs'] if `var'==.
end
subst v68 v65 291 /* missing before March 86 */ 
subst v10 v48 291 /* missing before March 86 */
subst v58 v48  97 /* missing before January 70 */
subst v60 v14 291 /* missing before March 86 */
subst v51 v14 291 /* missing before March 86 */ 
subst v61 v14 291 /* missing before March 86 */ 
drop month
/* local i 2
while `i'<=68 {
    if v`i'[1]==. {drop v`i'}
    local i=`i'+1
    } */
mkmat v*, matrix(IPA)
matrix IPA=IPA'
drop v*
svmat double IPA
rename IPA445 coluna
local i 1
while `i'<=444 {
  local yr=61+int(`i'/12+(1-1/12))
  if (`i'+11)/12==int((`i'+11)/12) {rename IPA`i' jan`yr'}
  capture label var jan`yr' "Jan-`yr'"
  if (`i'+10)/12==int((`i'+10)/12) {rename IPA`i' feb`yr'}
  capture label var feb`yr' "Feb-`yr'"
  if (`i'+9)/12==int((`i'+9)/12)   {rename IPA`i' mar`yr'}
  capture label var mar`yr' "Mar-`yr'"
  if (`i'+8)/12==int((`i'+8)/12)   {rename IPA`i' apr`yr'}
  capture label var apr`yr' "Apr-`yr'"
  if (`i'+7)/12==int((`i'+7)/12)   {rename IPA`i' may`yr'}
  capture label var may`yr' "May-`yr'"
  if (`i'+6)/12==int((`i'+6)/12)   {rename IPA`i' jun`yr'}
  capture label var jun`yr' "Jun-`yr'"
  if (`i'+5)/12==int((`i'+5)/12)   {rename IPA`i' jul`yr'}
  capture label var jul`yr' "Jul-`yr'"
  if (`i'+4)/12==int((`i'+4)/12)   {rename IPA`i' aug`yr'}
  capture label var aug`yr' "Aug-`yr'"
  if (`i'+3)/12==int((`i'+3)/12)   {rename IPA`i' sep`yr'}
  capture label var sep`yr' "Sep-`yr'"
  if (`i'+2)/12==int((`i'+2)/12)   {rename IPA`i' oct`yr'}
  capture label var oct`yr' "Oct-`yr'"
  if (`i'+1)/12==int((`i'+1)/12)   {rename IPA`i' nov`yr'}
  capture label var nov`yr' "Nov-`yr'"
  if (`i')/12==int((`i')/12)       {rename IPA`i' dec`yr'}
  capture label var dec`yr' "Dec-`yr'"
  local i=`i'+1
}
order coluna
label var coluna "Sector Definition FGV"
sort coluna
merge coluna using `n100fgv'
drop if _merge==1
drop _merge
order niv100 niv80 nivmap coluna
sort niv100

/* Build Investment Deflators */
/*----------------------------*/
/* Niv80 x Deflators Matrix */
keep niv100 nivmap jan62-dec`lstyr'
drop if niv100==1010 | niv100==1020  /* Make computers 1030 */
sort niv100 nivmap
quietly by niv100 nivmap: keep if _n==1
local yr 62
while `yr'<=`lstyr' {
    quietly egen mjan`yr'=mean(jan`yr'), by(nivmap)
    quietly egen mfeb`yr'=mean(feb`yr'), by(nivmap)
    quietly egen mmar`yr'=mean(mar`yr'), by(nivmap)
    quietly egen mapr`yr'=mean(apr`yr'), by(nivmap)
    quietly egen mmay`yr'=mean(may`yr'), by(nivmap)
    quietly egen mjun`yr'=mean(jun`yr'), by(nivmap)
    quietly egen mjul`yr'=mean(jul`yr'), by(nivmap)
    quietly egen maug`yr'=mean(aug`yr'), by(nivmap)
    quietly egen msep`yr'=mean(sep`yr'), by(nivmap)
    quietly egen moct`yr'=mean(oct`yr'), by(nivmap)
    quietly egen mnov`yr'=mean(nov`yr'), by(nivmap)
    quietly egen mdec`yr'=mean(dec`yr'), by(nivmap)
    drop jan`yr'-dec`yr'
    rename mjan`yr' jan`yr'
    rename mfeb`yr' feb`yr'
    rename mmar`yr' mar`yr'
    rename mapr`yr' apr`yr'
    rename mmay`yr' may`yr'
    rename mjun`yr' jun`yr'
    rename mjul`yr' jul`yr'
    rename maug`yr' aug`yr'
    rename msep`yr' sep`yr'
    rename moct`yr' oct`yr'
    rename mnov`yr' nov`yr'
    rename mdec`yr' dec`yr'
    local yr=`yr'+1
}
sort nivmap 
quietly by nivmap: keep if _n==1
drop niv100
preserve
   use "brazprod\filters\niv10080", clear
   drop niv100 
   sort niv80
   quietly by niv80: keep if _n==1
   sort nivmap
   save `tmp1', replace
restore
joinby nivmap using `tmp1'
drop nivmap
order niv80 jan86-dec`lstyr'
sort niv80
save `master', replace

/* Merge data & create capital formation deflators */
local round 1
/* Round 1: Total, 2: Machinery, 3: Vehicles, 4: Computers, 5: Other */
while `round'<=5 {
local yr 62
while `yr'<=`lstyr' {
if `yr'<=85 {use `capf85', clear}
       else {use `capf`yr'', clear}
if `round'==2 {replace capform=0 if (niv80~=801 & niv80~=1101)}  /* Machinery */
if `round'==3 {replace capform=0 if (niv80~=802 & niv80~=1201 & niv80~=1301)}  /* Vehicles */
if `round'==4 {replace capform=0 if (niv80~=1001)}                /* Computers */
if `round'==5 {replace capform=0 if (niv80~=1401 & niv80~=3201)}  /* Other */
sort niv80
merge niv80 using `master'
keep if _merge==3
drop _merge
    quietly egen tot=sum(capform)
    replace capform=capform/tot
    drop tot
gen nwjan`yr'=jan`yr'*capform
gen nwfeb`yr'=feb`yr'*capform
gen nwmar`yr'=mar`yr'*capform
gen nwapr`yr'=apr`yr'*capform
gen nwmay`yr'=may`yr'*capform
gen nwjun`yr'=jun`yr'*capform
gen nwjul`yr'=jul`yr'*capform
gen nwaug`yr'=aug`yr'*capform
gen nwsep`yr'=sep`yr'*capform
gen nwoct`yr'=oct`yr'*capform
gen nwnov`yr'=nov`yr'*capform
gen nwdec`yr'=dec`yr'*capform
drop jan`yr'-dec`yr'
egen jan`yr'=sum(nwjan`yr')
egen feb`yr'=sum(nwfeb`yr')
egen mar`yr'=sum(nwmar`yr')
egen apr`yr'=sum(nwapr`yr')
egen may`yr'=sum(nwmay`yr')
egen jun`yr'=sum(nwjun`yr')
egen jul`yr'=sum(nwjul`yr')
egen aug`yr'=sum(nwaug`yr')
egen sep`yr'=sum(nwsep`yr')
egen oct`yr'=sum(nwoct`yr')
egen nov`yr'=sum(nwnov`yr')
egen dec`yr'=sum(nwdec`yr')
keep niv80 jan`yr' feb`yr' mar`yr' apr`yr' may`yr' jun`yr' jul`yr' aug`yr' sep`yr' oct`yr' nov`yr' dec`yr'
format niv80 %4.0f
label var niv80 "NIVEL 80"
label var jan`yr' "Jan-`yr'"
label var feb`yr' "Feb-`yr'"
label var mar`yr' "Mar-`yr'"
label var apr`yr' "Apr-`yr'"
label var may`yr' "May-`yr'"
label var jun`yr' "Jun-`yr'"
label var jul`yr' "Jul-`yr'"
label var aug`yr' "Aug-`yr'"
label var sep`yr' "Sep-`yr'"
label var oct`yr' "Oct-`yr'"
label var nov`yr' "Nov-`yr'"
label var dec`yr' "Dec-`yr'"
format jan`yr' feb`yr' mar`yr' apr`yr' may`yr' jun`yr' jul`yr' aug`yr' sep`yr' oct`yr' nov`yr' dec`yr' %10.0g  
drop niv80
keep if _n==1
if `round'==1 {gen str10 captype="total"}
if `round'==2 {gen str10 captype="machinery"}
if `round'==3 {gen str10 captype="vehicles"}
if `round'==4 {gen str10 captype="computers"}
if `round'==5 {gen str10 captype="other"}
label var captype "Type of Capital"
order captype jan`yr' feb`yr' mar`yr' apr`yr' may`yr' jun`yr' jul`yr' aug`yr' sep`yr' oct`yr' nov`yr' dec`yr'
save `c`yr'', replace
local yr=`yr'+1
}
use `c62', replace
local yr 63
while `yr'<=`lstyr'  {
    merge using `c`yr''
    drop _merge
    local yr=`yr'+1
}
save `cap`round'', replace
local round=`round'+1
}
use `cap1', clear
append using `cap2'
append using `cap3'
append using `cap4'
append using `cap5'
sort captype
reshape long jan feb mar apr may jun jul aug sep oct nov dec, i(captype) j(year)
rename jan mon1
rename feb mon2
rename mar mon3
rename apr mon4
rename may mon5
rename jun mon6
rename jul mon7
rename aug mon8
rename sep mon9
rename oct mon10
rename nov mon11
rename dec mon12
reshape long mon, i(captype year) j(month)
egen indcap=group(captype)
rename mon idx
gen date=ym(year+1900,month)
format date %tm
drop year month captype
reshape wide idx, i(date) j(indcap)
rename idx1 idxcomp
rename idx2 idxmach
rename idx3 idxothr
rename idx4 idxtotl
rename idx5 idxvehc

/* Calculate numerator for each year and capital type */
/*----------------------------------------------------*/
gen sigmam=.
local yr=86
while `yr'<=91 {
local currmo=((19`yr'-1961)*12)     /* This series starts in Jan-1962 */
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(idxtotl[`currmo']/idxtotl)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(idxmach[`currmo']/idxmach)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'    /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(idxothr[`currmo']/idxothr)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(idxvehc[`currmo']/idxvehc)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(idxcomp[`currmo']/idxcomp)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop if date<=ym(1991,11)
expand 300 if date==ym(1991,12)
sort date
replace date=_n+83 if _n<=299
local yr 92
while `yr'<=98 {
local currmo=((19`yr'-1966)*12)     /* This series starts in Jan-1967 */
replace sigmam=_n-`currmo'+12*`totyr'    /* `totyr' years for total */
replace sigma=. if sigmam<1 | sigmam>(12*`totyr')
gen _dummy=(idxtotl[`currmo']/idxtotl)*sigmam
egen total`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`machyr'    /* `machyr' years for machinery */
replace sigma=. if sigmam<1 | sigmam>(12*`machyr')
gen _dummy=(idxmach[`currmo']/idxmach)*sigmam
egen machin`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`othryr'    /* `othryr' years for other */
replace sigma=. if sigmam<1 | sigmam>(12*`othryr')
gen _dummy=(idxothr[`currmo']/idxothr)*sigmam
egen othr`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`veicyr'    /* `veicyr' years for vehicles */
replace sigma=. if sigmam<1 | sigmam>(12*`veicyr')
gen _dummy=(idxvehc[`currmo']/idxvehc)*sigmam
egen vehicl`yr'=sum(_dummy)
drop _dummy
replace sigmam=_n-`currmo'+12*`compyr'    /* `compyr' years for computers */
replace sigma=. if sigmam<1 | sigmam>(12*`compyr')
gen _dummy=(idxcomp[`currmo']/idxcomp)*sigmam
egen comput`yr'=sum(_dummy)
drop _dummy
local yr=`yr'+1
}
drop date idx* sigmam
keep in 1
gen id=1
reshape long buildg total machin othr vehicl comput, i(id) j(year)
drop id
sort year
merge year using `otn'
drop _merge
gen buildgas=buildg/ot1bld
gen buildgsl=buildg/ot2bld
gen totalas=total/ot1tot
gen totalsl=total/ot2tot
gen machinas=machin/ot1mac
gen machinsl=machin/ot2mac
gen otheras=othr/ot1oth
gen othersl=othr/ot2oth
gen vehiclas=vehicl/ot1veh
gen vehiclsl=vehicl/ot2veh
gen computas=comput/ot1com
gen computsl=comput/ot2com
drop buildg total machin othr vehicl comput ot1* ot2*
label var year "Calendar Year"
label var buildgas "Corr. Factor Buildings (Stock)"
label var buildgsl "Corr. Factor Buildings (Sales)"
label var totalas "Corr. Factor Total (Stock)"
label var totalsl "Corr. Factor Total (Sales)"
label var machinas "Corr. Factor Machinery (Stock)"
label var machinsl "Corr. Factor Machinery (Sales)"
label var otheras "Corr. Factor Other (Stock)"
label var othersl "Corr. Factor Other (Sales)"
label var vehiclas "Corr. Factor Vehicles (Stock)"
label var vehiclsl "Corr. Factor Vehicles (Sales)"
label var computas "Corr. Factor Computers (Stock)"
label var computsl "Corr. Factor Computers (Sales)"
order year buildgas buildgsl machinas machinsl vehiclas vehiclsl computas computsl otheras othersl totalas totalsl
sort year
preserve
    use "brazprod\deflate\capcorr-di.dta", clear
    keep year buildg*
    save `tmp2', replace  
restore
merge year using `tmp2', update  /* Get general building deflator */
drop _merge
save "brazprod\deflate\capcorr-ipa.dta", replace
