* OLLEY-PAKES
* (In general, try to use *.do with /k64000)

* Order of Estimation Steps:
* --------------------------

* [... ESTIMATION ...]
* Note: Erase directories in tfpest/estimate/estmat and tfpest/estimate/bstrp

global root "c:/data"
* global root "//acsnfs4.ucsd.edu/unix-home/econgrad/marcm/"

cd "$root"
adopath + "$root/brazprod/%stata/ado"
set more off
clear
set mem 150m

* do $root/brazprod/%stata/%1prepare-pia/%1OrderOfCommands.do
* do $root/brazprod/%stata/%2prep-addl-series/%2OrderOfCommands.do
* do $root/brazprod/%stata/%3deflate&capstruct-pia/%3OrderOfCommands.do
* do $root/brazprod/%stata/%4tfp/match-data.do 
* do $root/brazprod/%stata/%4tfp/prep-data.do 

* do $root/brazcomp/%stata/%2prepare-agg/prep-aggregates.do 
* do $root/brazcomp/%stata/%2prepare-agg/prep-data.do 
* do $root/brazcomp/%stata/%2prepare-agg/prep-sec-reg.do 
* do $root/brazcomp/%stata/%2prepare-agg/prep-concentration.do 

* do $root/tfpest/%stata/%1tfp-comp/prep-seclvl.do
* do $root/tfpest/%stata/%1tfp-comp/prep-vars-others.do

global dp = "$root/tfpest/%stata/%2olley-pakes"

* do $dp/prep-data.do 
             /* Prepares data for Olley-Pakes estimation */
             /* Entering data: "brazprod/use-compl-`ext'`fdfl'.dta" (where `ext' can be "di", "ipa", or a general deflator  and `fdfl' in 1 2 or empty)
                               "brazprod/cgc-lig/firmhead.dta" */
             /* OUTPUT: "tfpest/use-tfp-`ext'`fdfl'-`outtype'-`trdtype'.dta"
                        "tfpest/use-tfp-`ext'`fdfl'-dummies.dta"
                        "tfpest/niv50.dta" */ 

* do $dp/olley-pakes-progs.do
             /* Reads estimation programs into memory */

* do $dp/olley-pakes-compreg.do  
                /* Performs OLS and FE regressions for comparisons */
                /* Data: 1986-1998, kappa and mu are set to zero for non-existing years */
                /* Entering data: "tfpest/use-tfp-`ext'`fdfl'-`outtype'-`trdtype'.dta"
                                  programs from olley-pakes-progs.do */
                /* OUTPUT:   none
                      LOG:   "tfpest/estimate/logs/compreg-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.log" 
                   MATRICES: "tfpest/estimate/estmat/mat-comp-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'/compols_`type'.dta" (where `type' in b se e r) 
                             "tfpest/estimate/estmat/mat-comp-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'/compfe_`type'.dta" (where `type' in b se e r) */

* do $dp/olley-pakes-survv.do  
                /* Performs only the second step of the Olley Pakes 3-step estimation procedure */
                /* Entering data: "tfpest/use-tfp-`ext'`fdfl'-`outtype'-`trdtype'.dta" */
                /* OUTPUT:   "tfpest/estimate/coeff-survvprob-`ext'`fdfl'.dta"
                      LOG:   "tfpest/estimate/logs/olley-pakes-survvprob-`ext'`fdfl'.log"
                   MATRICES: "tfpest/estimate/estmat/pfct/prob_`type'.dta" (where `type' in b se e r)"
                             "tfpest/estimate/estmat/pfct/logt_`type'.dta" (where `type' in b se e r)" */

* do $dp/olley-pakes-survv-all.do  
        /* Performs estimation comparable to the second step of the Olley Pakes 3-step procedure (for reporting only) */
        /* Entering data: "tfpest/use-tfp-`ext'`fdfl'-`outtype'-`trdtype'.dta"
                          "brazprod/exp-imp/exp-imp.dta" */
        /* OUTPUT:   none
              LOG:   "tfpest/estimate/logs/olley-pakes-survvprob-`ext'`fdfl'.log"
           MATRICES: "tfpest/estimate/estmat/all/prob_`type'.dta" (where `type' in b se e)"
                     "tfpest/estimate/estmat/all/logt_`type'.dta" (where `type' in b se e)" */

global posinv = ""
* do $dp/olley-pakes.do
global posinv = "-posinv"
* do $dp/olley-pakes.do  
global posinv = "-nomkt"
* do $dp/olley-pakes.do  
                /* Performs the Olley Pakes 3-step estimation procedure */
                /* Data: 1986-1998, kappa and mu are set to zero for non-existing years */
                /* Entering data: "tfpest/use-tfp-`ext'`fdfl'-`outtype'-`trdtype'.dta"
                                  "tfpest/estimate/coeff-survvprob-`ext'`fdfl'.dta"
                                  "tfpest/estimate/predict-endogseclvl-`ext'`fdfl'.dta"
                                  programs from olley-pakes-progs.do */
                /* OUTPUT:   "tfpest/estimate/coeff$posinv-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.dta"
                      LOG:   "tfpest/estimate/logs/olley-pakes-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.log" 
                   MATRICES: "tfpest/estimate/estmat/mat-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'/stp`estmat'.dta" (where `estmat' in "1bet" "3bet" "1sdv" "3sdv") */


* do $dp/olley-pakes-bstrp-progs.do  /* Reads estimation programs for olley-pakes-bstrp.do into memory, beyond olley-pakes-progs.do */

global posinv = ""
* do $dp/olley-pakes-bstrp.do
global posinv = "-posinv"
* do $dp/olley-pakes-bstrp.do
global posinv = "-nomkt"
* do $dp/olley-pakes-bstrp.do
                /* Performs bootstrap on steps 1 and 3 of the Olley Pakes estimation procedure */
                /* Entering data: "tfpest/use-tfp-`ext'`fdfl'-`outtype'-`trdtype'.dta"
                                  "tfpest/estimate/coeff$posinv-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.dta"
                                  "tfpest/estimate/estmat/mat-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'/stp`estmat'.dta" (where `estmat' in "1bet" "3bet" "1sdv" "3sdv")
                                  programs from olley-pakes-progs.do
                                  programs from olley-pakes-bstrp-progs.do */
                /*   OUTPUT: "tfpest/estimate/bstrp/niv`nivdsp'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-run`run'.dta" (where ``run' is the running number of the bootstrapping attempt for Niv50 `nivdsp')
                        LOG: "tfpest/estimate/logs/olley-pakes-bstrp-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-run`run'.log" (where `run' is the running number of the bootstrapping attempt) */

global posinv = ""
* do $dp/olley-pakes-bstrp-append.do
global posinv = "-posinv"
* do $dp/olley-pakes-bstrp-append.do
global posinv = "-nomkt"
* do $dp/olley-pakes-bstrp-append.do
                /* Summarizes the present state of the bootstraps for all sectors */
                /* Entering data: "tfpest/estimate/bstrp/niv`niv'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-run`run'.dta" (where `run' is a running number of the bootstrapping attempt for Niv50 `niv') */
                /*   OUTPUT: on screen
                        LOG: none */
