version 7
gprefs set custom2 pen1_thick 1
gprefs set custom2 pen2_thick 1
gprefs set custom2 pen3_thick 1
gprefs set custom2 pen4_thick 1
gprefs set custom2 pen5_thick 1
gprefs set custom2 pen6_thick 1
gprefs set custom2 pen1_color 0 0 0     /* black  */
gprefs set custom2 pen2_color 220 50 25 /* red    */
gprefs set custom2 pen3_color 80 80 80  /* gray   */
gprefs set custom2 pen4_color 0 140 65  /* green  */
gprefs set custom2 pen5_color 0 128 190 /* blue   */
gprefs set custom2 pen6_color 155 0 0   /* red    */
gprefs set custom2 pen7_color 128 0 128 /* purple */
gprefs set custom2 pen8_color 0 80 0    /* green  */
gprefs set window scheme custom2
gprefs set window displaythick on
translator set gph2eps scheme custom2


use "c:/texdocs/tfpest/stata-origs/estcompsh_tbl.dta", clear

rename _rowname coeff 
foreach niv in 08 14 22 26 31 {
    local scale = niv`niv'_eop[_N]
    foreach type in eop costsh {
        replace niv`niv'_`type' = . if niv`niv'_`type'==-999
        replace niv`niv'_`type' = niv`niv'_`type' * `scale' if _n<_N
        }
    }

reshape long niv08_ niv14_ niv22_ niv26_ niv31_, i(coeff) j(type) string 
foreach var in niv08 niv14 niv22 niv26 niv31 {
    rename `var'_ `var'
    }
rename niv08 niv8 
reshape long niv, i(coeff type) j(niv50) 
rename niv share_ 
reshape wide share_, i(type niv50) j(coeff) string 
replace type = "EOP" if type=="eop" 
replace type = "Expend." if type=="costsh" 
label var share_capsm "Capital share" 
label var share_labfsm "Labor share" 
label var share_intm "Intermediate goods share" 
gen str12 typniv = "(" + substr("0"+string(niv50),-2,2) + ") " + type 
sort typniv 
graph7 share_labfsm share_capsm share_intm, bar stack by(typniv) ylab(0,.2,.4,.6,.8,1,1.2) yline(1) alt saving("c:/texdocs/tfpest/fig/graphs/bar-coeffs", replace) 
translate "c:/texdocs/tfpest/fig/graphs/bar-coeffs.gph" "c:/texdocs/tfpest/fig/graphs/bar-coeffs.eps", translator(gph2eps) replace
