* TFPEST

* Order of Steps:
* ---------------

* [... AGGREGATE TFP ...]

global root "c:/data"
* global root "//acsnfs4.ucsd.edu/unix-home/econgrad/marcm/"

cd "$root"
adopath + "$root/brazprod/%stata/ado"
program drop _all
set more off
clear
set mem 150m

gprefs set custom2 pen1_thick 1
gprefs set custom2 pen2_thick 1
gprefs set custom2 pen3_thick 1
gprefs set custom2 pen4_thick 1
gprefs set custom2 pen5_thick 1
gprefs set custom2 pen6_thick 1
gprefs set custom2 pen1_color 0 0 0     /* black  */
gprefs set custom2 pen2_color 220 50 25 /* red    */
gprefs set custom2 pen3_color 0 140 65  /* green  */
gprefs set custom2 pen4_color 80 80 80  /* gray   */
gprefs set custom2 pen5_color 128 0 128 /* purple */
gprefs set custom2 pen6_color 0 128 190 /* blue   */
gprefs set custom2 pen7_color 155 0 0   /* red    */
gprefs set custom2 pen8_color 0 80 0    /* green  */
gprefs set window scheme custom2
gprefs set window scheme monochrome
* gprefs set window displaythick on
* translator set gph2eps scheme custom2
translator set gph2eps scheme monochrome

global esttype "eop"

global dp1 = "c:/data/tfpest/%stata/%4agg-tfp"
global dp2 = "c:/data/braztfp/%stata/%1output"

* do $dp1/prodlevel.do
                /* Calculates Log TFP and Log LP levels */
                /* Entering data: "brazprod/use-compl-`ext'`fdfl'.dta" (from match-data.do)
                                  "brazprod/cgc-lig/firmhead.dta" (from %1/analyz-refer-emp.do)
                                  "tfpest/estimate/coeff-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.dta" (from olley-pakes.do) */
                /*   OUTPUT: "brazprod/data/prodlevel-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.dta" */

global simul "tfpest"
* do $dp2/prep-data.do                   /* Prepares data for subsequent calculations */
* do $dp2/tfp-prodlevel-annual.do        /* Annual Log TFP level for Graphs - Step 1/2 */
* do $dp2/tfp-prodlevel-annual-agg.do    /* Annual Log TFP level for Graphs - Step 2/2 */
* do $dp2/tfp-prodlevel-annual-decomp.do /* Annual Log TFP level decompositions */

* do $dp1/graph-allind.do 
    /* Prepares graphs for manufacturing as a whole (as in braztfp/%stata/%2graphs/graph-allind.do) */
    /* Entering data: "tfpest/aggtfp/prodlevel`rebase'-annual-compagg-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.dta" 
                      "tfpest/aggtfp/prodlevel`rebase'-annual-agg-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.dta" */
    /* OUTPUT: "c:/texdocs/tfpest/fig/graphs/tfplevel-`esttype'-`ext'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-agg2.eps"
               "c:/texdocs/tfpest/fig/graphs/tfplevel-entrext-`esttype'-`ext'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-agg2.eps"
               "c:/texdocs/tfpest/fig/graphs/tfplevel-entrext-`esttype'-`ext'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-agg2-ind14.eps"
               "c:/texdocs/tfpest/fig/graphs/tfplevel-reg-`esttype'-`ext'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-agg2.eps"
               "c:/texdocs/tfpest/fig/graphs/tfplevel-reg-`esttype'-`ext'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'-agg2-ind14.eps" */

do $dp1/graph-productivity-levels.do
    /* Graphs Annual Aggregate TFP and LP levels (as in brazprod/%stata/%7graphs/graph-productivity-levels.do) */
    /* Entering data: "tfpest/aggtfp/prodlevel1-annual-compagg-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.dta" (from %6 and braztfp/%1/tfp-prodlevel-annual-agg.do) */
    /* OUTPUT: graphs "c:/texdocs/brazprod/graphs/tfplevel-`n'-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.gph"  (where `n' represents `aggtype')
               eps    "c:/texdocs/brazprod/graphs/tfplevel-`n'-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.gph"  (where `n' represents `aggtype')
               graphs "c:/texdocs/brazprod/graphs/lplevel-`n'-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.gph"  (where `n' represents `aggtype')
               eps    "c:/texdocs/brazprod/graphs/lplevel-`n'-`esttype'-`ext'`fdfl'-`outtype'-`trdtype'-`fetype'-`polynl'`xeff'.gph"  (where `n' represents `aggtype') */
* graph used:
* tfplevel-pia-ellgom-eop-ipa2-output-notrend-fe-3x-agg1.eps
